/*
* This file is part of Firestorm NIDS
* Copyright (c) 2001 Gianni Tedesco
*
*    Firestorm is free software; you can redistribute it and/or modify
*    it under the terms of the GNU General Public License as published by
*    the Free Software Foundation; either version 2 of the License, or
*    (at your option) any later version.
*
*    Firestorm is distributed in the hope that it will be useful,
*    but WITHOUT ANY WARRANTY; without even the implied warranty of
*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*    GNU General Public License for more details.
*
*    You should have received a copy of the GNU General Public License
*    along with Firestorm; if not, write to the Free Software
*    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/


#ifndef __RULESET_SNORT_PLUGIN_HEADER_INCLUDED__
#define __RULESET_SNORT_PLUGIN_HEADER_INCLUDED__

#include <g_globals.h>
#include <s_globals.h>
#include <matcher.h>
#include <plugins.h>

//typedef struct snort {
//	list_head_t	l;
//	char		*key;
//	char 		*val;
//}snort_t, *p_snort;

typedef enum snort_e {
	SNORT_NULL,
	SNORT_BACKWARDS,
	SNORT_FORWARDS,
	SNORT_BIDIRECTIONAL
}snort_ret;

/* Parse one single rule */
snort_ret snort_parse_rule(char *rule);
int snort_parse_body(char *body);

#define NVAL_NORMAL	0
#define NVAL_NEGATE	1
#define NVAL_AUTO	2

/* Add item to internal list, and cleanup internal list */
int snort_link_element(const char *key, const char *val, int nval);
void snort_cleanup_internal(void);

int snort_optimise_rule(p_kv tokens);
int snort_invert_rule(p_kv tokens);

int snort_add_rule(void);

#define IS_RULE(x) ( \
	x[0] != '\0' && \
	x[0] != '#'  && \
	x[0] != '\n' && \
	x[0] != '\r' )

#endif /* __RULESET_SNORT_PLUGIN_HEADER_INCLUDED__ */
