/*
* This file is part of Firestorm NIDS
* Copyright (c) 2001 Gianni Tedesco
*
*    Firestorm is free software; you can redistribute it and/or modify
*    it under the terms of the GNU General Public License as published by
*    the Free Software Foundation; either version 2 of the License, or
*    (at your option) any later version.
*
*    Firestorm is distributed in the hope that it will be useful,
*    but WITHOUT ANY WARRANTY; without even the implied warranty of
*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*    GNU General Public License for more details.
*
*    You should have received a copy of the GNU General Public License
*    along with Firestorm; if not, write to the Free Software
*    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/


#include <drop.h>
#include <s_util.h>

PLUGIN_DECLARE_STD_IMPORTS;
proc_target_add		add_target;

target_action_e drop_target(p_packet p, void *priv, p_rule r)
{
	return TARGET_DONE;
}

void *drop_validate(char *token)
{
	return 0xdeadbeef;
}

uint _PLUGIN_INIT (p_plugin_in in, p_plugin_out out)
{
	PLUGIN_CHECK_PARAMS(in);
	PLUGIN_IMPORT_STD;
	
	add_target=in->add_target;
	
	PLUGIN_NAME("target/drop");
	PLUGIN_DESC("Stops furthur processing on a matched packet");
	PLUGIN_VERS(1,0);
	
	add_target("DROP",
		drop_target,
		drop_validate,
		in->templates.t_cleanup_ptr);
	
	return PLUGIN_ERR_OK;
}

/* This is where we would cleanup our shit */
uint _PLUGIN_UNLOAD (void)
{
	return PLUGIN_ERR_OK;
}
